/* Copyright (c) 2003 Timo Sirainen */

#include "lib.h"
#include "istream-lob.h"
#include "istream-internal.h"

struct lob_istream {
	struct _istream istream;

	sqlo_db_handle_t dbh;
	sqlo_lob_desc_t lob;
};

static void _close(struct _iostream *stream __attr_unused__)
{
}

static void _destroy(struct _iostream *stream __attr_unused__)
{
}

static void _set_max_buffer_size(struct _iostream *stream __attr_unused__,
				 size_t max_size __attr_unused__)
{
}

static void _set_blocking(struct _iostream *stream __attr_unused__,
			  int timeout_msecs __attr_unused__,
			  void (*timeout_cb)(void *) __attr_unused__,
			  void *context __attr_unused__)
{
}

static ssize_t _read(struct _istream *stream)
{
	return stream->pos - stream->skip;
}

static void _seek(struct _istream *stream, uoff_t v_offset)
{
	if (stream->istream.v_offset <

	stream->skip = v_offset;
	stream->istream.v_offset = v_offset;
}

static void _skip(struct _istream *stream, uoff_t count)
{
	struct lob_istream *lstream = (struct lob_istream *) stream;

	lstream->skip_left += count - (stream->pos - stream->skip);
	stream->skip = stream->pos = 0;
	stream->istream.v_offset += count;
}

struct istream *
i_stream_create_lob(sqlo_db_handle_t dbh, sqlo_lob_desc_t lob, pool_t pool)
{
	struct lob_istream *stream;

	stream = p_new(pool, struct lob_istream, 1);
	stream->dbh = dbh;
	stream->lob = lob;

	stream->istream.iostream.close = _close;
	stream->istream.iostream.destroy = _destroy;
	stream->istream.iostream.set_max_buffer_size = _set_max_buffer_size;
	stream->istream.iostream.set_blocking = _set_blocking;

	stream->istream.read = _read;
	stream->istream.skip_count = _skip;
	stream->istream.seek = _seek;

	return _i_stream_create(&stream->istream, pool, -1, 0, 0);
}
