#ifndef __ORACLE_MAIL_H
#define __ORACLE_MAIL_H

struct cached_header {
	struct cached_header *next;

	size_t name_len;
	const char *name, *value;
};

struct oracle_mail_data {
	struct mail_full_flags flags;
	time_t received_date;
	uoff_t size;

	time_t sent_time;
	int sent_timezone;

	struct cached_header *headers;
	struct message_part *parts;
	const char *envelope, *body, *bodystructure;
        struct message_part_envelope_data *envelope_data;

	struct mail_index_record *rec;
	struct istream *stream;
        //struct message_size hdr_size, body_size;

	unsigned int parse_header:1;
	unsigned int save_sent_time:1;
	unsigned int save_envelope:1;
	unsigned int hdr_size_set:1;
	unsigned int body_size_set:1;
};

struct oracle_mail {
	struct mail mail;
	struct oracle_mail_data data;

	char answered, flagged, deleted, seen, draft;
	char received_date[15];
	unsigned int message_size;
        sqlo_lob_desc_t lob;

	pool_t pool;
	struct oracle_mailbox *obox;
};

void oracle_mail_init(struct oracle_mailbox *obox, struct oracle_mail *mail);
int oracle_mail_next(struct oracle_mail *mail);
void oracle_mail_deinit(struct oracle_mail *mail);

#endif
