#ifndef __ORACLE_SQL_H
#define __ORACLE_SQL_H

#define S(x) ((char *) (x))

void orasql_set_error(struct oracle_storage *storage, const char *error);

sqlo_stmt_handle_t
orasql_prepare(struct oracle_storage *storage, const char *fmt, ...)
	__attr_format__(2, 3);
sqlo_stmt_handle_t
orasql_define_output(struct oracle_storage *storage,
		     sqlo_stmt_handle_t sth, const char *fmt, ...)
	__attr_scanf__(3, 4);
int orasql_define_pos(struct oracle_storage *storage, sqlo_stmt_handle_t sth,
		      int pos, int type, void *arg, unsigned int arg_size);

int orasql_execute(struct oracle_storage *storage, sqlo_stmt_handle_t sth);
int orasql_fetch(struct oracle_storage *storage, sqlo_stmt_handle_t sth);
int orasql_fetch_one(struct oracle_storage *storage, sqlo_stmt_handle_t sth);

int orasql_exec(struct oracle_storage *storage, const char *fmt, ...)
	__attr_format__(2, 3);
int orasql_close(struct oracle_storage *storage, sqlo_stmt_handle_t sth);

int orasql_mailbox_fetch_one(struct oracle_mailbox *obox,
			     sqlo_stmt_handle_t sth);

int orasql_rollback(struct oracle_storage *storage);
int orasql_commit(struct oracle_storage *storage);

#endif
